/*
Autor:		Rafael Alberto Moreno Parra
URL:		http://darwin.50webs.com
Clase:		Inicializa.
Lenguaje:	C++

Propsito:
Inicializa las variables para la simulacin

Mtodos:

*/
#include "Aleatorio.h"

class Inicializa {
public:
	int iValor;

	struct stDatosSimul
	{
		//Entradas y salidas
		unsigned int NUMENTRADA;
		char sENTRADA[400];
		char sSALIDA[400];

		unsigned int TAMANOMATRIZ; //Tamao de la Matriz
		unsigned int TAMEXPRESION; //Tamao mximo de la expresin algebraica (maximo 100)
		unsigned int GENERACAMINOS; //Cuantos caminos de tamao 2 a TAMANOMATRIZ-1 genera
		unsigned int CAMBIACAMINOS; //Cuantas veces cambia el camino generado

		//1. Tabla I: Se utiliza despus de vacio, parntesis que abre, funcin, operador
		unsigned int T1FUNCION;
		unsigned int T1PARENTE;
		unsigned int T1VARIABX;
		unsigned int T1NUMEROS;

		//2. Tabla II: Se utiliza despus de X y parntesis que cierra.
		unsigned int T2OPERADO;
		unsigned int T2PARENTE;

		//Entradas y salidas
		float fENTRADA[100];
		float fSALIDA[100];
	};  
	 //Datos Programacin Gentica (inicializacin)
	struct stDatosSimul stDatPG;

	//Objeto que administra los nmeros aleatorios
	Aleatorio objAzar;

	/* Crea las tablas de probabilidades para formar las ecuaciones
		Son tres(3) tablas:
		1. Tabla I: Se utiliza despus de vacio, parntesis que abre, funcin, operador
		2. Tabla II: Se utiliza despus de (0.01 a 0.99) y parntesis que cierra. */
	char sbTabla1[100]; //Como debe sumar 100% por la probabilidad
	char sbTabla2[100];

	void vPantallaIni(void);
	void vIniciaAzar(void);
    int iLeeArchivoIni(void);
	void vDeshaceIO(char *m_sSerieNum, int iEntraSale);
	void vCreaTablas(void);
	void vCreaEcuacion(char *sbEcuacion);
	void vRetadores(unsigned int *iRetadorA, unsigned int *iRetadorB, unsigned int *iRetadorC);
	void vMutaEcuacion(char *sbEcuacion);
};
