/* Tiene toda la lista de los acumulados 
 * 
 * Ejemplo:  7 - (x * y) + 20 / (3 - z) + 6 + (w / z * 4)
 *
 * @1: w / z * 4
 * @2: 3 - z
 * @3: x * y
 * @4: 7 - @3 + 20 / @2 + 6 + @1
 *
 */

#include "NodoExprCompleja.h" 

class NodoBus
{
public:
	unsigned int iCodigo;
	unsigned char cFuncion; //Funciones como seno, coseno, tangente, ...
	NodoExprCompleja *objComplejo;
	NodoBus *FlechaI;
	NodoBus *FlechaD;
	
	NodoBus(void);
    NodoBus(NodoBus *objNodo);
	~NodoBus(void);
	void vAdiciona(unsigned char cTipo, float fNumero, unsigned char cVariable, unsigned int iAcumulador, unsigned char cOperador);
};
