/* Tiene toda la lista de los acumulados 
 * 
 * Ejemplo:  7 - (x * y) + 20 / (3 - z) + 6 + (w / z * 4)
 *
 * @1: w / z * 4
 * @2: 3 - z
 * @3: x * y
 * @4: 7 - @3 + 20 / @2 + 6 + @1
 *
 */

#include <stdio.h>
#include "NodoBus.h"

//Constructor 1
NodoBus::NodoBus(void)
{
	//printf("Crea NodoBus\n");
	this->FlechaI = NULL;
    this->FlechaD = NULL;
	this->objComplejo = NULL;
}

//Constructor 2
NodoBus::NodoBus(NodoBus *objNodo)
{
	//printf("Crea NodoBus\n");
    this->FlechaI = objNodo;
    this->FlechaD = NULL;
	this->objComplejo = NULL;
    objNodo->FlechaD = this; /* OJO a esto */
}
	
void NodoBus::vAdiciona(unsigned char cTipo, float fNumero, unsigned char cVariable, unsigned int iAcumulador, unsigned char cOperador)	
{
	objComplejo = new NodoExprCompleja(cTipo, fNumero, cVariable, iAcumulador, cOperador, objComplejo);		
}

NodoBus::~NodoBus(void)
{
	//printf("Destruye NodoBus\n");
}
